// Annihilate Memory by Gynvael Coldwind of Vexillium
// http://gynvael.coldwind.pl
// http://vexillium.org
// mailto: gynvael@vexillium.org
//
// Note:
//  This code is designed for Windows XP SP{0-3}
//  The code is highly experimental, so YOU USE IT AT YOUR OWN RISK!
//  Compile with MinGW g++
//
// License (BSD):
//  Copyright (c) 2008, Gynvael Coldwind of Vexillium
//  All rights reserved.
//
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are met:
//      * Redistributions of source code must retain the above copyright
//        notice, this list of conditions and the following disclaimer.
//      * Redistributions in binary form must reproduce the above copyright
//        notice, this list of conditions and the following disclaimer in the
//        documentation and/or other materials provided with the distribution.
//      * Neither the name of the Gynvael Coldwind nor Vexillium nor the
//        names of its contributors may be used to endorse or promote products
//        derived from this software without specific prior written permission.
//
//  THIS SOFTWARE IS PROVIDED BY Gynvael Coldwind ''AS IS'' AND ANY
//  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
//  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
//  DISCLAIMED. IN NO EVENT SHALL Gynvael Coldwind BE LIABLE FOR ANY
//  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
//  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
//  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
//  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
//  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE
#include<windows.h>
#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<stdint.h>

unsigned char *
FileGetContent(const char *FileName, size_t *Size);

WORD GetFS(void) { __asm__(".ascii \"\\x0F\\xA0\\x58\""); }

int
main(void)
{
  // Get TEB
  LDT_ENTRY ldt;
  HANDLE thdl = GetCurrentThread();

  GetThreadSelectorEntry(thdl, GetFS(), &ldt);

  DWORD Off = ldt.BaseLow | (ldt.HighWord.Bytes.BaseMid << 16) | (ldt.HighWord.Bytes.BaseHi << 24);
  BYTE *Teb = (BYTE*)Off;
  printf("TEB: %.8x\n", (uint32_t)Off);

  // Get stack size
  DWORD ThreadStackTop    = *(DWORD*)&Teb[8];
  DWORD ThreadStackBottom = *(DWORD*)&Teb[4];

  MEMORY_BASIC_INFORMATION MemInfo;
  for(;;)
  {
    VirtualQuery((LPCVOID)(ThreadStackTop), &MemInfo, sizeof(MemInfo));
    if(MemInfo.State == MEM_FREE) 
      break;

    ThreadStackTop -= 0x1000;
    printf("Seeking stack size: %.8x: %.8x (%s)\r",
        (uint32_t)ThreadStackTop, (uint32_t)MemInfo.RegionSize, 
        MemInfo.State == MEM_COMMIT ? "MEM_COMMIT" :
        MemInfo.State == MEM_FREE ? "MEM_FREE" : "MEM_RESERVE"
        );
  }
  putchar('\n');

  // Copy shellcode
  size_t CodeSize = 0;
  uint8_t* Code = FileGetContent("shellcode", &CodeSize);
  printf("Shellcode: %.8x bytes\n", CodeSize);

  // Copy the shellcode
  puts("Copying shellcode...");
  memcpy(&Teb[0x800], Code, CodeSize);

  // Remove memory protection
  puts("Removing memory protection...");
  DWORD Addr = 0;
  DWORD OldPrivs;
  while(Addr < 0x80000000)
  {    
    VirtualProtect((LPVOID)Addr, 1, PAGE_EXECUTE_READWRITE, &OldPrivs);
    Addr += 0x1000;
  }

  // Free memory excluding the stack
  puts("Freeing memory...");
  Addr = 0;
  while(Addr < 0x80000000)
  {
    if(!(Addr >= ThreadStackTop && Addr <= ThreadStackBottom))
    {
      VirtualFree((LPVOID)Addr, 0, MEM_RELEASE);
    }
    Addr += 0x1000;
  }

  // Call the second part
  ((void(*)())&Teb[0x800])();

  // Never reached
  return 0;
}

// File aquirement
unsigned char *
FileGetContent(const char *FileName, size_t *Size)
{
  FILE *f;
  size_t FileSize;
  unsigned char *Data;

  // Open the file
  f = fopen(FileName, "rb");
  if(!f)
    return NULL;

  // Get file size
  fseek(f, 0, SEEK_END);
  FileSize = ftell(f);
  fseek(f, 0, SEEK_SET);

  // Allocate memory
  Data = (unsigned char*)malloc(FileSize + 1);
  if(!Data)
  {
    fclose(f);
    return NULL;
  }

  // Read file content
  FileSize = fread(Data, 1, FileSize, f);
  Data[FileSize] = 0;

  // Close the file
  fclose(f);

  // Return
  if(Size) // Size is optional
    *Size = FileSize;
  return Data;
}

