; Annihilate Memory by Gynvael Coldwind of Vexillium
; http://gynvael.coldwind.pl
; http://vexillium.org
; mailto: gynvael@vexillium.org
;
; Note:
;  This code is designed for Windows XP SP{0-3}
;  The code is highly experimental, so YOU USE IT AT YOUR OWN RISK!
;  Compile with Netwide Assembler aka NASM
;
; License (BSD):
;  Copyright (c) 2008, Gynvael Coldwind of Vexillium
;  All rights reserved.
;
;  Redistribution and use in source and binary forms, with or without
;  modification, are permitted provided that the following conditions are met:
;      * Redistributions of source code must retain the above copyright
;        notice, this list of conditions and the following disclaimer.
;      * Redistributions in binary form must reproduce the above copyright
;        notice, this list of conditions and the following disclaimer in the
;        documentation and/or other materials provided with the distribution.
;      * Neither the name of the Gynvael Coldwind nor Vexillium nor the
;        names of its contributors may be used to endorse or promote products
;        derived from this software without specific prior written permission.
;
;  THIS SOFTWARE IS PROVIDED BY Gynvael Coldwind ''AS IS'' AND ANY
;  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
;  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
;  DISCLAIMED. IN NO EVENT SHALL Gynvael Coldwind BE LIABLE FOR ANY
;  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
;  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
;  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
;  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
;  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
;  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE
[bits 32]
[org 0deadbabeh]

;
; Macros
;
%macro UnmapViewOfFile 1
  push %1 ; Address
  push -1 ; Current process
  call NtUnmapViewOfSection
%endmacro

;
; Code
;
start:
  ;
  ; Unmap memory from 0 to 0x7FFFFFFF
  ;
  xor ebx, ebx
  __unmap_loop_start:

    ; Call
    UnmapViewOfFile   ebx

    ; Iterate
    add ebx, 1000h
    test ebx, ebx
    jns __unmap_loop_start ; Do not call unmap over 0x80000000

  ;
  ; Do something - now the process contains only:
  ; - TEB (unfreeable)
  ; - PEB (unfreeable)
  ; - Main stack thread
  ; - Kernel memory area (unfreeable)
  ;
  jmp short $

;
; Syscall operations
;
%define SYSCALL_NtUnmapViewOfSection 10Bh ; XP SP0/SP1/SP2/SP3

KiSlowSystemCall:
  lea edx, [esp+8]
  int 0x2E
  ret

NtUnmapViewOfSection:
  mov eax, SYSCALL_NtUnmapViewOfSection
  call KiSlowSystemCall
  retn 8




